﻿Friend Class FrmMain

	Private Canvas As Bitmap
	Private ReadOnly Random As New Random
	Private ReadOnly Lines As New List(Of Point)
	Private ReadOnly TimestampPacks As New TimestampPackList

	Private Sub FrmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
		CreateLines()
	End Sub

	Private Sub CreateLines()
		For x = 0 To 1000
			Lines.Add(New Point(x, Random.Next(300) + 100))
		Next
	End Sub

	Private Sub Button1_Click(sender As Object, e As EventArgs) Handles BtnDraw.Click
		TimestampPacks.SetStartTime(Date.Now)
		DrawIn(PnlCanvas)
	End Sub

	Public Sub DrawIn(Panel As Panel)
		TimestampPacks.Add("vor explitizem Zeichnen")
		Panel.BackgroundImage = Nothing
		If Canvas IsNot Nothing Then Canvas.Dispose()
		Canvas = New Bitmap(Panel.Width, Panel.Height)

		Using g As Graphics = Graphics.FromImage(Canvas)
			DrawStuffWith(g)
		End Using
		TimestampPacks.Add("nach explitizem Zeichnen")
		Panel.BackgroundImage = Canvas
		TimestampPacks.Add("nach BackgroundImage-Zuweisung")
	End Sub

	Private Sub DrawStuffWith(g As Graphics)
		g.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
		g.CompositingQuality = Drawing2D.CompositingQuality.HighQuality
		g.Clear(Color.Black)

		g.DrawLines(Pens.Green, Lines.ToArray)
	End Sub

	Private Sub Panel1_Paint(sender As Object, e As PaintEventArgs) Handles PnlCanvas.Paint
		TimestampPacks.Add("Beginn Paint-EH")
		If ChbUsePaintEventHandler.Checked Then DrawStuffWith(e.Graphics)
		TimestampPacks.Add("Ende Paint-EH")
		LogTimestampsAndClearThem()
	End Sub

	Private Sub LogTimestampsAndClearThem()
		For Each TimestampPack In TimestampPacks
			Console.WriteLine(TimestampPack.CheckpointName & ": " & TimestampPack.Timestamp.TotalMilliseconds)
		Next
		TimestampPacks.Clear()
	End Sub
End Class